Subject: Re: bug#24379: [PATCH] lisp/bindings.el: Bind (yank-pop -1) to M-Y

From: Nils Berg <[email-masked]>
Date: Wed, 14 Sep 2016 11:42:57 +0200

Some healthy discussion here, so let me preface this by saying I appreciate
all of you working to keep the default bindings useful and not excessive.

That said, I still feel there should be a single binding for (yank-pop -1).
Here's why:

First, all of the other commands that traverse something (that I can think
of) have an opposite bound to an equally convenient combination.
C-n/C-p and C-f/C-b, C-v/M-v, C-s/C-r are some examples off the top of my
head.

Of course 'M-- M-y' works, but that's like saying 'M-- C-n' does the same
thing as C-p.
(As a side note, I'll admit I didn't actually know/remember M-- is a
shorthand for 'C-u -1'. That does make the common case of overshooting the
item you want by 1 a lot less painful.)

Second, I fully agree with Clément that just because a command is trivial,
it's automatically unhelpful to bind it. Again, see C-n/C-p.

And lastly, if a user has a custom binding for M-Y or C-M-y (I'm not dead
set on either), that will still prevail.
I don't see why they'd be any more reluctant to override those than M-y,
which you said lots of people do.
It's pretty hard to google "M-y", much less "M-Y", without Google deciding
I'm actually looking for "my", so I'm going to trust you on that.

So that's my 2 Cents. If you're still unconvinced, feel free to close this
:)

On Tue, Sep 6, 2016 at 5:58 PM, Drew Adams <[email-masked]> wrote:

> > > Users can always override any key bindings, of course.
> > > But many users are hesitant to override default bindings,
> > > for whatever reasons.
> ...
> > > Yes, and my `M-y' is only turned on in Icicle minor mode (but
> > > which I am always in).  You can drop that example, if you like,
> > > and just google for `emacs "M-y"' if you would like to see what
> > > other users do with `M-y'.
> >
> > I'm having trouble reconciling these two statements: on the one hand
> > people don't like overriding existing bindings, but on the other hand
> > many people override the existing M-y binding?
>
> Maybe you're having trouble because you're trying too hard to
> argue. ;-)
>
> Many users do override default bindings.  And many do not.
>
> In any case, the proposal was about `M-Y', which is not bound
> by default.
>
> > > My point was the _general_ one that I stated: (1) Many users
> > > have their own uses of `M-y' and `C-M-y'.  And (2) adding this
> > > particular binding is not helpful - it is trivial for anyone
> > > to add it, if they really want it.
> >
> > I don't understand. All bindings are trivial to add. That doesn't make
> any
> > of them less helpful.
>
> It's a trivial command, which is not hard for a user to discover
> or consider binding.  And as you yourself pointed out, `M-- M-y'
> does the same thing.
>
> You're trying too hard to pick a fight, I'm afraid.
>
> Do _you_ think `M-Y' should be bound by default to the suggested
> command?  If so, please present some supporting arguments.
>